
\ Quick-access registers and ports for each DMA channel.

CREATE MASKREG
 0x0A C, 0x0A C, 0x0A C, 0x0A C, 0xD4 C, 0xD4 C, 0xD4 C, 0xD4 C,
CREATE MODEREG
 0x0B C, 0x0B C, 0x0B C, 0x0B C, 0xD6 C, 0xD6 C, 0xD6 C, 0xD6 C,
CREATE CLEARREG
 0x0C C, 0x0C C, 0x0C C, 0x0C C, 0xD8 C, 0xD8 C, 0xD8 C, 0xD8 C,

CREATE PAGEPORT
 0x87 C, 0x83 C, 0x81 C, 0x82 C, 0x8F C, 0x8B C, 0x89 C, 0x8A C,
CREATE ADDRPORT
 0x00 C, 0x02 C, 0x04 C, 0x06 C, 0xC0 C, 0xC4 C, 0xC8 C, 0xCC C,
CREATE COUNTPORT
 0x01 C, 0x03 C, 0x05 C, 0x07 C, 0xC2 C, 0xC6 C, 0xCA C, 0xCE C,

: _DMA_XFER (  length page offset mode DMA_channel -- )

    \ Don't let anyone else mess up what we're doing.  
    DISABLE
    \ Set up the DMA channel so we can use it.  This tells the DMA 
    \ that we're going to be using this channel.  (It's masked) 
    DUP>R 0x04 OR  MASKREG R@ + C@ PC!

    \ Clear any data transfers that are currently executing. 
     0x00         CLEARREG R@ + C@ PC!

    \ Send the specified mode to the DMA. 

                   MODEREG R@ + C@ PC!
\    [CHAR] { EMIT
    \ Send the offset address.  The first byte is the low base offset, the 
    \ second byte is the high offset. 
       0x100 /MOD SWAP
   ( LOW_BYTE  )   ADDRPORT R@ + C@ PC!
   (  HI_BYTE  )   ADDRPORT R@ + C@ PC!

    \ Send the physical page that the data lies on. 

                   PAGEPORT R@ + C@ PC!

    \ Send the length of the data.  Again, low byte first. 
       0x100 /MOD SWAP
   ( LOW_BYTE  )   COUNTPORT R@ + C@ PC!
   (  HI_BYTE  )   COUNTPORT R@ + C@ PC!

    \ Ok, we're done.  Enable the DMA channel (clear the mask). 

               R@  MASKREG R> + C@ PC!
    \ Re-enable interrupts before we leave. 
\    [CHAR] | EMIT
     ENABLE
\    [CHAR] } EMIT
  ;

: DMA_XFER ( length address  read DMA_channel -- )
        ( DMA_channel )        DUP>R
        SWAP ( read ) 0=
        IF     0x48 +
        ELSE   0x44 +
        THEN                      >R

      ( address ) DUP  0xFFFF AND >R

      ( address )  16 RSHIFT      >R

                     ( length ) 1- R> R> R> R>

(  length page offset mode DMA_channel )
        _DMA_XFER ;


