
CREATE DMAINFO
    0x87 C, 0x00 C, 0x01 C,
    0x83 C, 0x02 C, 0x03 C,
    0x81 C, 0x04 C, 0x05 C,
    0x82 C, 0x06 C, 0x07 C,


\ this sets up a DMA trasfer between a device and memory.  Pass the DMA
\ channel number (0..3), the physical address of the buffer and transfer
\ length.  If 'read' is TRUE, then transfer will be from memory to device,
\ else from the device to memory.

: DMA_XFER
 || channel physaddr length read     page offset ||
 (( length physaddr read channel ))
\   assert(channel < 4);
   
\ calculate dma page and offset 

   physaddr 0x10 RSHIFT  -> page
   physaddr 0xFFFF AND -> offset 
   length 1- -> length  \ with dma, if you want k bytes, you ask for k - 1 

    DISABLE   \ disable irq's 
   
\    set the mask bit for the channel 
      channel 4 OR  0x0A  PC!  
   
\  clear flipflop 
      0   0x0C  PC!  
   
\  set DMA mode (write+single+r/w) 
      read 0= IF 0x48 ELSE 0x44 THEN channel +  0x0B  PC!  
   
\ set DMA page 
    page DMAINFO channel 3 * +  0 +  C@  PC!
   
\ set DMA offset 
    offset 0xFF AND   DMAINFO channel 3 *  +  1+  C@  PC! \  low byte 
    offset 8  RSHIFT  DMAINFO channel 3 *  +  1+  C@  PC! \ high byte
   
\ set DMA length 
    length 0xFF AND   DMAINFO channel 3 * +  2 +  C@  PC! \  low byte 
    length 8  RSHIFT  DMAINFO channel 3 * +  2 +  C@  PC! \ high byte
   
\ clear DMA mask bit 
  channel 0xA  PC!
   
     ENABLE \ enable irq's 
;
